Support german umlauts and whitespaces in login string

2010-08-18 08:42 - Max Meier

Status: New Start date: 2010-08-18

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

I am using redmine to authenticate with a Lotus Notes LDAP server. Unfortunately the validated login string can contain umlauts and

whitespaces, like in the name "Max Müller". Redmine by default does neither allow non-ascii characters nor whitespaces in the login

string.

If there is no other reason, why special characters must not be used, I think one could localize the validation pattern by extracting it

into config/locales to be configured individually for each language.

For myself now, I changed app/models/user.rb

validates_format_of :login, :with => /^[a-z0-9_\-@\.]*$/i

to

validates_format_of :login, :with => /^[a-z0-9_ äüöéßÄÜÖ\-@\.]*$/iu

which suits my needs very well.    

Please let me know, if this is a good idea.

Related issues:

Related to Redmine - Patch #811: Username validation - allow spaces... New 2008-03-08

Related to Redmine - Feature #21923: net-ldap 0.12.0 - 0.12.1 dropped support... Closed

History

#1 - 2011-12-14 11:03 - Max Meier

- File patch.txt added

Upgrading to redmine 1.2.2 I created a patch for app/models/user.rb, which allows german umlauts and accent d'aigu in login names. The regexp

pattern is extended with unicode quoted characters, so it should run also without requiring cp1232 or such.

Could you please integrate this into official redmine versions?

#2 - 2012-01-24 13:06 - Daniel Albuschat

+1

I ran into the same problem with 1.3.0 and used the same "hack" to fix it (I manually edited user.rb).

Why hasn't this patch been incorporated?

Why is that validation necessary, anyways?

#3 - 2013-03-13 15:25 - Piotr Karasinski

Just stumbled upon the same issue with danish characters. The name of this thread should maybe be changed to "national characters in login string"

or something. Anyway the difference for me was that these national characters are not ASCII, and apparently the app/models/user.rb file in its

unmodified form is ASCII encoded. So I needed to add the following code on the very top of the file:

# -*- coding: utf-8 -*-

otherwise it failed with an error (at least it did for me) when accessing Redmine.
#4 - 2013-03-13 21:06 - Daniel Felix

Well we encountered the same Problem. It would be great to have this enabled in the next release.

I currently disabled just the Loginname validation as we are using LDAP for our user management. But this way we just need to change some core

code on every release to get this thing working.

#5 - 2013-09-24 17:11 - Philipp erpel

I just want to add myself as one more victim of this shortcoming. It's 2013 and we should be able to use proper usernames by now. Please consider

to extend the allowable characters.

#6 - 2015-04-08 13:28 - Gregor Borsemirk

I also just came across this issue where I was authenticating against LDAP.

This user had a german 'umlaut' in his user name and redmine always was rejecting a login with 'invalid user name'

The fix from Max Meier works for me in Redmine 2.6.3

So thanks to Max!

#7 - 2015-12-08 13:20 - int redmine

It is not only login causing issues when containg umlauts.

I also get an Internal error

An error occurred on the page you were trying to access.

If you continue to experience problems please contact your Redmine administrator for assistance.

If you are the Redmine administrator, check your log files for details about the error.

 during account creation on first time login by LDAP.

This is also caused by umlauts in first name/Last name

account creation through normal register procedure is working, when first name/Last name contain umlauts.

#8 - 2015-12-08 14:49 - Toshi MARUYAMA

int redmine wrote:

It is not only login causing issues when containg umlauts.

I also get an Internal error

 This is because of #21453.

#9 - 2016-01-13 14:19 - Andreas Deininger

+1

I ran into the same problem with Redmine version 3.2.0 and successfully used the patch above to overcome the limitation I encountered.

I would appreciate if this issue could be addressed in a future version of Redmine.

#10 - 2016-02-02 10:34 - Go MAEDA

- File feature-6166.diff added

Here is a patch for r15144.

[:alnum:] covers umlauts.

/\A[[:alnum:]_\-@\.]*\z/i

#11 - 2016-02-12 04:51 - Toshi MARUYAMA

- Related to Feature #21923: net-ldap 0.12.0 - 0.12.1 dropped support of UTF-8 added

#12 - 2022-03-15 16:45 - Andreas Deininger

More than 6 years later, I again ran into the same problem when updating my Redmine instance to version 4.2.4. Again, I successfully used the patch

above to overcome the limitation I encountered.

I really would like to see this issue addressed in future Redmine versions.

Pleas note, that I'm not the only one, this note

https://www.redmine.org/issues/6166 is basically the same problem with german characters, but no one seems to 

be interested.
https://www.redmine.org/issues/21453
https://www.redmine.org/projects/redmine/repository/svn/revisions/15144
https://www.redmine.org/issues/35355#note-4


#13 - 2022-03-16 09:16 - C S

+1

Files

patch.txt 1000 Bytes 2011-12-14 Max Meier

feature-6166.diff 1.45 KB 2016-02-02 Go MAEDA
